CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


OBJ

  v     : "VocalTract"

  
VAR

  byte  aa,ga,gp,vp,vr,f1,f2,f3,f4,na,nf,fa,ff  'vocal tract parameters
  

PUB start

  v.start(@aa, 10, 11, -1)              'start tract, output to pins 10,11
 
  repeat                                'keep repeating talk
    gp := rnd(50, 100)                  'set random glottal pitch
    vp := rnd(4, 24)                    'set random vibrato pitch
    vr := rnd(4, 10)                    'set random vibrato rate
    talk                                'talk


PRI talk

  setformants(170, 1100, 2600, 3200)    'set formants for M
  nf := 2900 * 100 / 1953               'set nasal for M
  na := 255
  v.go(1)

  aa := 10                              'ramp up M
  ga := 30
  v.go(150)

  setformants(700, 900, 2800, 4500)     'set formants for O
  na := 0                               'nasal off
  v.go(50)                              'transition to O
  v.go(150)                             'sustain

  setformants(200, 1550, 2500, 4500)    'set formants for N
  nf := 1550 * 100 / 1953               'set nasal for N
  na := 255
  v.go(100)                             'transition to N
  v.go(100)                             'sustain

  aa := 0                               'ramp down N
  ga := 0
  v.go(100)
                                        
  na := 0                               'nasal off 
  ff := 120                             'set frication for S
  v.go(1)
                                     
  fa := 10                              'ramp up S
  v.go(150)

  fa := 0                               'ramp down S
  v.go(75)

  ff := 80                              'set frication for T
  v.go(50)                              'sustain silence briefly
  
  fa := 10                              'ramp up T
  v.go(20)
  
  setformants(580, 1200, 1500, 4700)    'set formants for R
  fa := 0                               'ramp down T
  v.go(20)

  aa := 10                              'ramp up R
  ga := 30
  v.go(50)                    
  v.go(150)                             'sustain
  
  aa := 0                               'taper down to silence
  ga := 0
  v.go(100)

  v.go(500)                             'pause


PRI setformants(s1, s2, s3, s4)

  f1 := s1 * 100 / 1953
  f2 := s2 * 100 / 1953
  f3 := s3 * 100 / 1953
  f4 := s4 * 100 / 1953


PRI rnd(low, high)

  return low + ||(?cnt // (high - low + 1))
